<?php
class ModelExtensionUniDownload extends Model {
	public function install() {
		$this->db->query("CREATE TABLE IF NOT EXISTS `".DB_PREFIX."news_to_download` (
		  `news_id` int(11) NOT NULL,
		  `download_id` int(11) NOT NULL,
		  PRIMARY KEY (`news_id`,`download_id`)
		) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
		
		$data = array(  
				'extension_install_id' => '',
				'code' => 'Downloadable Files Unishop2 News',
				'name' => 'Downloadable Files Unishop2 News',
				'author' => 'Tom',
				'version' => '1.0',
				'link' => 'Downloadable Files Unishop2 News',
				'xml' => '
				<modification>
				  <name>Downloadable Files Unishop2 News</name>
				  <code>Downloadable Files Unishop2 News</code>
				  <version>1.0</version>
				  <author>Tom</author>
				  <link>Downloadable Files Unishop2 News</link>
				  
		<file path="admin/model/extension/module/uni_news.php">
			<operation>
			  <search><![CDATA[if (isset($data[\'related_products\']) ) {]]></search>
			  <add position="before"><![CDATA[
				if (isset($data[\'news_download\'])) {
					foreach ($data[\'news_download\'] as $download_id) {
						$this->db->query("INSERT INTO " . DB_PREFIX . "news_to_download SET news_id = \'" . (int)$news_id . "\', download_id = \'" . (int)$download_id . "\'");
					}
				}
			  ]]></add>
			</operation>     
			<operation>
			  <search><![CDATA[if (isset($data[\'related_products\'])) {	]]></search>
			  <add position="before" offset="1"><![CDATA[
				$this->db->query("DELETE FROM " . DB_PREFIX . "news_to_download WHERE news_id = \'" . (int)$news_id . "\'");

				if (isset($data[\'news_download\'])) {
					foreach ($data[\'news_download\'] as $download_id) {
						$this->db->query("INSERT INTO " . DB_PREFIX . "news_to_download SET news_id = \'" . (int)$news_id . "\', download_id = \'" . (int)$download_id . "\'");
					}
				}
			  ]]></add>
			</operation>    
			<operation>
			  <search><![CDATA[public function deleteNews($news_id) {]]></search>
			  <add position="after"><![CDATA[$this->db->query("DELETE FROM " . DB_PREFIX . "news_to_download WHERE news_id = \'" . (int)$news_id . "\'");]]></add>
			</operation>   
			<operation>
			  <search><![CDATA[public function getNewsRelatedProduct($news_id) {]]></search>
			  <add position="before"><![CDATA[
				  public function getnewsDownloads($news_id) {
					  $news_download_data = array();

					  $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_to_download WHERE news_id = \'" . (int)$news_id . "\'");

					  foreach ($query->rows as $result) {
						  $news_download_data[] = $result[\'download_id\'];
					  }

					  return $news_download_data;
				  }
				  public function getTotalNewsByDownloadId($download_id) {
					  $query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "news_to_download WHERE download_id = \'" . (int)$download_id . "\'");

					  return $query->row[\'total\'];
				  }
			  ]]></add>
			</operation>
		  </file> 
		  <file path="admin/language/ru-ru/extension/module/uni_news.php">
			<operation>
			  <search><![CDATA[$_[\'heading_title\'] = \'<b>UniShop2</b> - Новостной модуль\';]]></search>
			  <add position="before"><![CDATA[
				  $_[\'entry_download\']         = \'Загрузки\';
				  $_[\'help_download\']          = \'(Автозаполнение)\';
			  ]]></add>
			  </operation>
		  </file>  
		  <file path="admin/controller/extension/module/uni_news.php">
			<operation>
			  <search><![CDATA[$this->load->model(\'catalog/product\');]]></search>
			  <add position="before"><![CDATA[
				// Downloads
				$this->load->model(\'catalog/download\');

				if (isset($this->request->post[\'news_download\'])) {
					$news_downloads = $this->request->post[\'news_download\'];
				} elseif (isset($this->request->get[\'news_id\'])) {
					$news_downloads = $this->model_extension_module_uni_news->getnewsDownloads($this->request->get[\'news_id\']);
				} else {
					$news_downloads = array();
				}

				$data[\'news_downloads\'] = array();

				foreach ($news_downloads as $download_id) {
					$download_info = $this->model_catalog_download->getDownload($download_id);

					if ($download_info) {
						$data[\'news_downloads\'][] = array(
							\'download_id\' => $download_info[\'download_id\'],
							\'name\'        => $download_info[\'name\']
						);
					}
				}
			  ]]></add>
			</operation>
		  </file>
		  <file path="admin/view/template/extension/module/uni_news_form.twig">
			<operation>
			  <search><![CDATA[<label class="col-sm-2 control-label">{{ entry_status }}</label>]]></search>
			  <add position="before" offset="1"><![CDATA[
				<div class="form-group">
				 <label class="col-sm-2 control-label">{{ entry_download }}</label>
				 <div class="col-sm-10">
				  <input type="text" name="download" value="" placeholder="{{ entry_download }}" id="input-download" class="form-control" /><br/>
				  <div id="news-download" class="overflow" style="height:150px;"> 
				   {% for news_download in news_downloads %}
					<div id="news-download{{ news_download.download_id }}">
					 <i class="fa fa-minus-circle"></i> {{ news_download.name }}
					 <input type="hidden" name="news_download[]" value="{{ news_download.download_id }}" />
					</div>
				   {% endfor %}
				  </div>
				 </div>
				</div>
			  ]]></add>
			</operation>
		  </file>
		  <!-- CATALOG PART-->
			<file path="catalog/model/extension/module/uni_news.php">
			<operation>
			  <search><![CDATA[public function getNewsStoryRelatedProduct($news_id) {]]></search>
			  <add position="before"><![CDATA[
				  public function getDownloads($news_id) {

					  $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_to_download pd LEFT JOIN " . DB_PREFIX . "download d ON(pd.download_id=d.download_id) LEFT JOIN " . DB_PREFIX . "download_description dd ON(pd.download_id=dd.download_id) WHERE news_id = \'" . (int)$news_id . "\' AND dd.language_id = \'" . (int)$this->config->get(\'config_language_id\')."\'");

					  return $query->rows;
				  }

				  public function getDownload($news_id, $download_id) {
				  $download="";
				  if($download_id!=0)$download=" AND d.download_id=".(int)$download_id;
					  $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "news_to_download pd LEFT JOIN " . DB_PREFIX . "download d ON(pd.download_id=d.download_id) LEFT JOIN " . DB_PREFIX . "download_description dd ON(pd.download_id=dd.download_id) WHERE news_id = \'" . (int)$news_id . "\' ".$download." AND dd.language_id = \'" . (int)$this->config->get(\'config_language_id\')."\'");

					  return $query->row;
				  }
				]]></add>
			  </operation>
		   </file> 
		  <file path="catalog/controller/information/uni_news_story.php">
			<operation>
			  <search><![CDATA[//related products]]></search>
			  <add position="before"><![CDATA[			  
			        $data[\'download_status\'] = $this->config->get(\'module_uni_download_status\');
					
					$data[\'downloads\'] = array();
					
					$results = $this->model_extension_module_uni_news->getDownloads($this->request->get[\'news_id\']);
					
					foreach ($results as $result) {
						if (file_exists(DIR_DOWNLOAD . $result[\'filename\'])) {
							$size = filesize(DIR_DOWNLOAD . $result[\'filename\']);
		 
							$i = 0;
		 
							$suffix = array(
								\'B\',
								\'KB\',
								\'MB\',
								\'GB\',
								\'TB\',
								\'PB\',
								\'EB\',
								\'ZB\',
								\'YB\'
							);
		 
							while (($size / 10024) > 1) {
								$size = $size / 10024;
								$i++;
							}
		 
							$data[\'downloads\'][] = array(
								\'date_added\' => date($this->language->get(\'date_format_short\'), strtotime($result[\'date_added\'])),
								\'name\'       => $result[\'name\'],
								\'size\'       => (isset($size))?round(substr($size, 0, strpos($size, \'.\') + 4), 2) . $suffix[$i]:false,
								\'href\'       => $this->url->link(\'information/uni_news_story/download\', \'&news_id=\'. $this->request->get[\'news_id\']. \'&download_id=\' . $result[\'download_id\'])
							);
						}
					} 
			  ]]></add>
			</operation>   
			<operation>
			  <search><![CDATA[private function getRelatedProduct() {]]></search>
			  <add position="before"><![CDATA[
			public function download() {

				$this->load->model(\'extension/module/uni_news\');

				if (isset($this->request->get[\'download_id\'])) {
					$download_id = $this->request->get[\'download_id\'];
				} else {
					$download_id = 0;
				}

				if (isset($this->request->get[\'news_id\'])) {
					$news_id = $this->request->get[\'news_id\'];
				} else {
					$news_id = 0;
				}

				$download_info = $this->model_extension_module_uni_news->getDownload($news_id, $download_id);
			

				if ($download_info) {
					$file = DIR_DOWNLOAD . $download_info[\'filename\'];
					$mask = basename($download_info[\'mask\']);
					$extension = strtolower(pathinfo($mask, PATHINFO_EXTENSION));
					if (!headers_sent()) {
						if (file_exists($file)) {
							if($extension == \'pdf\') {
								$content_type = \'application/pdf\';
								$content_disposition = \'inline\';
							} else {
								$content_type = \'application/octet-stream\';
								$content_disposition = \'attachment\';
							}
							
							header(\'Content-Type: \' . $content_type);
							header(\'Content-Disposition: \' . $content_disposition . \'; filename = "\' . ($mask ? $mask : basename($file)) . \'"\');
							header(\'Expires: 0\');
							header(\'Cache-Control: must-revalidate, post-check=0, pre-check=0\');
							header(\'Pragma: public\');
							header(\'Content-Length: \' . filesize($file));

							if (ob_get_level()) {
								ob_end_clean();
							}

							readfile($file, \'rb\');

							exit();
						} else {
							exit(\'Error: Could not find file \' . $file . \'!\');
						}
					} else {
						exit(\'Error: Headers already sent out!\');
					}
				} else {
					$this->redirect(HTTP_SERVER . \'index.php?route=account/download\');
				}
			}
			
			  ]]></add>
			</operation>
		  </file>
		  <file path="catalog/view/theme/unishop2/template/information/uni_news_story.twig">
			<operation>
			  <search><![CDATA[{% if related_products %}]]></search>
			  <add position="before"><![CDATA[
				{% if download_status %}
					<div class="blog-info">
						{% if downloads %}			
						<div class="heading">Файлы для скачивания</div>			
						{% for download in downloads %}
						<div class="download_file col-md-4">
                            <a data-action="file" href="{{ download.href }}" target="_blank">
								<div class="icone"><i class="fas fa-file-download"></i></div>
								<div class="link">{{ download.name }}</div>
								<div class="size">{{ download.size }}</div>
							</a>
						</div>
						{% endfor %}
						{% endif %} 
					</div>
				{% endif %} 
			  ]]></add>
			</operation>
		  </file> 
		  <!-- For Seopro -->
		  <file path="system/library/seopro.php">
			<operation>
				<search><![CDATA[case \'information_id\':]]></search>
				<add position="after"><![CDATA[case \'download_id\':]]></add>
			</operation>
	     </file> 

				</modification>',
            'status' => 1
        );  
		
		$this->load->model('setting/modification');

		$mod = $this->model_setting_modification->getModificationByCode('Downloadable Files Unishop2 News');

		if (empty($mod)) {$mod = $this->model_setting_modification->getModificationByCode('Downloadable Files Unishop2 News');}
		if (empty($mod)) {$this->model_setting_modification->addModification($data);
		} elseif (
		    $mod['code'] != 'Downloadable Files Unishop2 News') {
				$this->model_setting_modification->deleteModification($mod['modification_id']);
				$this->model_setting_modification->addModification($data);
		   }
	}
	public function uninstall() {
	  $this->db->query("DROP TABLE IF EXISTS `".DB_PREFIX."news_to_download`");
	}	
}